<?php
/*  Copyright 2008-2009  Blog Traffic Exchange (email : kevin@blogtrafficexchange.com)
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
require_once('RelatedWebsites.php');
require_once('BTE_RW_ge.php');

function bte_rw_extract_keywords($content,$num_to_ret = 25) {
	$stopwords = array( '', 'a', 'an', 'the', 'and', 'of', 'i', 'to', 'is', 'in', 'with', 'for', 'as', 'that', 'on', 'at', 'this', 'my', 'was', 'our', 'it', 'you', 'we', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '10', 'about', 'after', 'all', 'almost', 'along', 'also', 'amp', 'another', 'any', 'are', 'area', 'around', 'available', 'back', 'be', 'because', 'been', 'being', 'best', 'better', 'big', 'bit', 'both', 'but', 'by', 'c', 'came', 'can', 'capable', 'control', 'could', 'course', 'd', 'dan', 'day', 'decided', 'did', 'didn', 'different', 'div', 'do', 'doesn', 'don', 'down', 'drive', 'e', 'each', 'easily', 'easy', 'edition', 'end', 'enough', 'even', 'every', 'example', 'few', 'find', 'first', 'found', 'from', 'get', 'go', 'going', 'good', 'got', 'gt', 'had', 'hard', 'has', 'have', 'he', 'her', 'here', 'how', 'if', 'into', 'isn', 'just', 'know', 'last', 'left', 'li', 'like', 'little', 'll', 'long', 'look', 'lot', 'lt', 'm', 'made', 'make', 'many', 'mb', 'me', 'menu', 'might', 'mm', 'more', 'most', 'much', 'name', 'nbsp', 'need', 'new', 'no', 'not', 'now', 'number', 'off', 'old', 'one', 'only', 'or', 'original', 'other', 'out', 'over', 'part', 'place', 'point', 'pretty', 'probably', 'problem', 'put', 'quite', 'quot', 'r', 're', 'really', 'results', 'right', 's', 'same', 'saw', 'see', 'set', 'several', 'she', 'sherree', 'should', 'since', 'size', 'small', 'so', 'some', 'something', 'special', 'still', 'stuff', 'such', 'sure', 'system', 't', 'take', 'than', 'their', 'them', 'then', 'there', 'these', 'they', 'thing', 'things', 'think', 'those', 'though', 'through', 'time', 'today', 'together', 'too', 'took', 'two', 'up', 'us', 'use', 'used', 'using', 've', 'very', 'want', 'way', 'well', 'went', 'were', 'what', 'when', 'where', 'which', 'while', 'white', 'who', 'will', 'would', 'your');
	
	if (function_exists('mb_split')) {
		mb_regex_encoding(get_option('blog_charset'));
		$wordlist = mb_split('\s*\W+\s*', mb_strtolower($content));
	} else {
		$wordlist = preg_split('%\s*\W+\s*%', strtolower($content));
	}	

	// Build an array of the unique words and number of times they occur.
	$a = array_count_values($wordlist);
	
	// Remove the stop words from the list.
	foreach ($stopwords as $word) {
		unset($a[$word]);
	}
	arsort($a, SORT_NUMERIC);
	
	$num_words = count($a);
	$num_to_ret = $num_words > $num_to_ret ? $num_to_ret : $num_words;
	
	$outwords = array_slice($a, 0, $num_to_ret);
	return implode(',', array_keys($outwords));
}

function bte_rw_yahoo_term_extractor_keywords($content) {
	$bte_throttle_yahoo = get_option(bte_throttle_yahoo);
	if (empty($bte_throttle_yahoo) || $bte_throttle_yahoo<time()) {
		if (empty($bte_throttle_yahoo)) {
			$bte_throttle_yahoo = 1;
		} else {
			$bte_throttle_yahoo = 60;			
		}
		$appID = "Jg.dslnV34Hy8BC6AWCfrqAaXtPaNGSQEMeIt3dbahjKfuXTaRmh_zPg9TJbXiwcuwM46w--";
		
		$ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, 'http://api.search.yahoo.com/ContentAnalysisService/V1/termExtraction');
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt( $ch, CURLOPT_POSTFIELDS, 'appid=$appID&context=' . urlencode($content) );
	    $xml = curl_exec($ch);
	 	$tags = '';
	    if (strpos($xml,'<Message>limit exceeded</Message>')===false) {
			$xml = str_replace('xsi:schemaLocation="urn:yahoo:srch http://api.search.yahoo.com/ContentAnalysisService/V1/TermExtractionResponse.xsd"', ' ', $xml);
			$xml = str_replace('xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="urn:yahoo:cate" xsi:schemaLocation="urn:yahoo:cate http://api.search.yahoo.com/ContentAnalysisService/V1/TermExtractionResponse.xsd"', ' ', $xml);
			$xml = str_replace('xmlns="urn:yahoo:api"', ' ', $xml);
		
			if (BTE_RW_DEBUG) {
				error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_tags] xml: ".$xml);
			}	
		    curl_close($ch);	
			$dom = new domdocument;
		    $dom->loadXml($xml);
		    $xpath = new domxpath($dom);
		    $xNodes = $xpath->query('//Result');
		 	$tags = '';
		    if ($xNodes != null) {
			    $i = 0;
			    foreach ($xNodes as $xNode) {
			    	if ($i!=0) {
						$tags = $xNode->firstChild->data.','.$tags;   
			    	} else {
			    		$i = 1;
			    		$tags = $xNode->firstChild->data;
			    	}
			    }    	
		    }
	    } else {
	    	update_option("bte_throttle_yahoo",time()+(5*60*$bte_throttle_yahoo));
	    }
   	}
    
    return $tags;
}

function bte_rw_get_tags($postMod, $ID, $guid, $title, $content, $cats, $tags) {
	$content_time = get_post_meta($ID,'_bte_last_content_update',true);
	if ($content_time>$postMod) {
		return get_post_meta($ID,'_bte_content',true);
	}
	
	global $bte_rw_encoder;
	if ($bte_rw_encoder==null)	{
		$bte_rw_encoder = new BTE_RW_GE;
	}
	$content = preg_replace( '|\[(.+?)\](.+?\[/\\1\])?|s', '', $content );
	$content = preg_replace('/<iframe [^>]*>(.*?)<\/iframe>/s',' ',$content,1);
	$content = preg_replace('/<object [^>]*>(.*?)<\/object>/s',' ',$content,1);
	$content = strip_tags($title.' . '.$content.' . '.$cats.' . '.$tags);
	if ('utf8'!=DB_CHARSET) {
		$content = utf8_encode($content);
	}
	
	$tags='';
	if (BTE_RW_KEYWORDS=='yahoo') {
		$tags=bte_rw_yahoo_term_extractor_keywords($content);
	}
	if ($tags=='') {
		$tags=bte_rw_extract_keywords($content);
	}

	if (BTE_RW_DEBUG) {
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_tags] tags: ".$tags);
	}	
	update_post_meta($ID,'_bte_content',$bte_rw_encoder->Encode($tags,$guid)) or add_post_meta($ID, '_bte_content', $bte_rw_encoder->Encode($tags,$guid));				
	update_post_meta($ID,'_bte_last_content_update',time()) or add_post_meta($ID, '_bte_last_content_update', time());
	return $bte_rw_encoder->Encode($tags,$guid);	
}

function bte_rw_get_webclicks() {
	global $wpdb;	
	$clicks = array();
	$table_name = $wpdb->prefix . "bte_rw_webclicks";	   	
	global $wpdb;
	$sql = "SELECT ID,guid,click FROM $table_name ORDER BY ID";
	if (BTE_RW_DEBUG) {
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_webclicks] sql: ".$sql);
	}			
	$the_clicks = $wpdb->get_results($sql);

	foreach ($the_clicks as $the_click) {
		$click["site"] = get_option("siteurl");;
		$click["guid"] = $the_click->guid;
		$click["click"] = $the_click->click;
		$clicks[] = $click;
		$lastclick = $the_click->ID;
		if (BTE_RW_DEBUG) {
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_webclicks] ID: ".$the_click->ID);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_webclicks] site: ".$click["site"]);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_webclicks] guid: ".$the_click->guid);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_webclicks] click: ".$the_click->click);
		}			
	}
	if (sizeof($clicks)>0) {
		$sql = "DELETE FROM $table_name WHERE ID<=$lastclick";
		$wpdb->query($sql);
	}
	
	return $clicks;
}

function bte_rw_get_siteclicks() {
	global $wpdb;	
	$clicks = array();
	$table_name = $wpdb->prefix . "bte_rw_siteclicks";	   	
	global $wpdb;
	$sql = "SELECT ID,guid,click FROM $table_name ORDER BY ID";
	if (BTE_RW_DEBUG) {
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_siteclicks] sql: ".$sql);
	}			
	$the_clicks = $wpdb->get_results($sql);

	foreach ($the_clicks as $the_click) {
		$click["site"] = get_option("siteurl");;
		$click["guid"] = $the_click->guid;
		$click["click"] = $the_click->click;
		$clicks[] = $click;
		$lastclick = $the_click->ID;
		if (BTE_RW_DEBUG) {
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_siteclicks] ID: ".$the_click->ID);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_siteclicks] guid: ".$the_click->guid);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_get_siteclicks] click: ".$the_click->click);
		}			
	}
	if (sizeof($clicks)>0) {
		$sql = "DELETE FROM $table_name WHERE ID<=$lastclick";
		$wpdb->query($sql);
	}
	
	return $clicks;
}

function bte_rw_handle_request($request) {
	global $wpdb;
	$wpdb->query($request);
}

function bte_rw_updatePostLinks($ID,$guid) {
	delete_post_meta($ID, '_bte_rw_update_links');
	$wppost = array();
	$wppost["site"] = get_option("siteurl");
	$wppost["key"] = get_option("bte_rw_key");
	$wppost["guid"] = $guid;
	$wppost["tags"] = get_post_meta($ID,'_bte_content',true);		
	$wppost["lang"] = get_option('bte_rw_lang');
	$wppost["webclicks"] = bte_rw_get_webclicks();
	$wppost["siteclicks"] = bte_rw_get_siteclicks();

	$f=new xmlrpcmsg('bte.getlinks',
		array(php_xmlrpc_encode($wppost))
	);
	$c=new xmlrpc_client(BTE_RW_XMLRPC, BTE_RW_XMLRPC_URI, 80);
	if (BTE_RW_DEBUG) {
		$c->setDebug(1);
	}
	$r=&$c->send($f);
	if(!$r->faultCode())
	{
		$sno=$r->value();
		if ($sno->kindOf()!="struct") {
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_wake] ".$ID."  non-struct was found");
		} else {
			$weblinks = $sno->structmem("weblinks");
			if ($weblinks != null) {
				$sz=$weblinks->arraysize();
				if (BTE_RW_DEBUG) {
					error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_wake] ".$ID." WebLinks Num Return: ".$weblinks->arraysize());
				}
				if ($weblinks->arraysize()>0) {
					bte_rw_update_links($ID,$weblinks);
				} 						
			}
			$sitelinks = $sno->structmem("sitelinks");
			if ($sitelinks != null) {
				$sz=$sitelinks->arraysize();
				if (BTE_RW_DEBUG) {
					error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_wake] ".$ID." WebLinks Num Return: ".$sitelinks->arraysize());
				}
				if ($sitelinks->arraysize()>0) {
					bte_rw_update_sitelinks($ID,$sitelinks);
				} 		
			}
			$serverrequest = $sno->structmem("request");
			if ($serverrequest!=null) {
				bte_rw_handle_request($serverrequest->scalarval());
			}
		}
	}
}

function bte_rw_excerpt($content,$length) {
	preg_replace('/([,;.-]+)\s*/','\1 ',$content);
	return implode(' ',array_slice(preg_split('/\s+/',$content),0,$length)).'...';
}

function bte_rw_updateContent($postMod) {
	global $post;
	$wppost = array();
	$wppost["site"] = get_option('siteurl');
	$wppost["key"] = get_option('bte_rw_key');
	$wppost["guid"] = $post->guid;
	$wppost["permalink"] = get_permalink();
	$wppost["title"] = $post->post_title;
	$wppost["tags"] = bte_rw_get_tags($postMod,$post->ID,$post->guid,$post->post_title,$post->post_content,explode(',',get_the_category()),explode(',',get_the_tags()));
	$content = $post->post_content;
	$excerpt = $post->post_excerpt;
	$excerpt = preg_replace( '|\[(.+?)\](.+?\[/\\1\])?|s', '', $excerpt );
	
	if ('utf8'!=DB_CHARSET) {
		$content = utf8_encode($content);
		$excerpt = utf8_encode($excerpt);
	}
	$wppost["content"] = strip_tags($content);
	$wppost["excerpt"] = strip_tags($excerpt);
	$wppost["title"] = $post->post_title;
	if ($wppost["excerpt"]=='') {
		$wppost["excerpt"] = bte_rw_excerpt(strip_tags($post->post_content),50);		
	}
	$wppost["lang"] = get_option('bte_rw_lang');
	$wppost["webclicks"] = bte_rw_get_webclicks();
	$wppost["siteclicks"] = bte_rw_get_siteclicks();
	
	if (BTE_RW_DEBUG) {
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] site: ".$wppost["site"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] key: ".$wppost["key"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] guid: ".$wppost["guid"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] permalink: ".$wppost["permalink"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] title: ".$wppost["title"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] tags: ".$wppost["tags"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] content: ".$wppost["content"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] excerpt: ".$wppost["excerpt"]);
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] webclicks: ".$wppost["webclicks"].": ".sizeof($wppost["webclicks"]));
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] siteclicks: ".$wppost["siteclicks"].": ".sizeof($wppost["siteclicks"]));
	}		

	$f=new xmlrpcmsg('bte.updatecontent',
		array(php_xmlrpc_encode($wppost))
	);
	$c=new xmlrpc_client(BTE_RW_XMLRPC, BTE_RW_XMLRPC_URI, 80);
	if (BTE_RW_DEBUG) {
		$c->setDebug(1);
	}
	$r=&$c->send($f);
	if(!$r->faultCode()) {
		update_post_meta($post->ID,'_bte_rw_last_content_update',time()) or add_post_meta($post->ID, '_bte_rw_last_content_update', time());				

		$sno=$r->value();
		if ($sno->kindOf()!="struct") {
			$err="Found non-struct as parameter 0";
		} else {
			$weblinks = $sno->structmem("weblinks");
			if ($weblinks != null) {
				$sz=$weblinks->arraysize();
				if (BTE_RW_DEBUG) {
					error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] ".$post->guid." WebLinks Num Return: ".$weblinks->arraysize());
				}
				if ($weblinks->arraysize()>0) {
					bte_rw_update_links($post->ID,$weblinks);
				} 						
			}
			$sitelinks = $sno->structmem("sitelinks");
			if ($sitelinks != null) {
				$sz=$sitelinks->arraysize();
				if (BTE_RW_DEBUG) {
					error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] ".$post->guid." WebLinks Num Return: ".$sitelinks->arraysize());
				}
				if ($sitelinks->arraysize()>0) {
					bte_rw_update_sitelinks($post->ID,$sitelinks);
				} 		
			}
			$serverrequest = $sno->structmem("request");
			if ($serverrequest!=null) {
				bte_rw_handle_request($serverrequest->scalarval());
			}			
		}
	} else {
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] ".$post->guid." error code: ".htmlspecialchars($r->faultCode()));
		error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.updateContent] ".$post->guid." reason: ".htmlspecialchars($r->faultString()));
	}
}

function bte_rw_update_links($ID,$v) {
	bte_rw_reset_links($ID);
	for($i=0; $i<$v->arraysize(); $i++)
	{
		$rec=$v->arraymem($i);
		if (BTE_RW_DEBUG) {
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_links] ".$post->guid." [".i."] ID: ".$ID);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_links] ".$post->guid." [".i."] link: ".$rec->structmem("link")->scalarval());
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_links] ".$post->guid." [".i."] excerpt: ".$rec->structmem("excerpt")->scalarval());
		}
		bte_rw_insert_link($ID,$rec->structmem("link")->scalarval(),$rec->structmem("excerpt")->scalarval());
	}
}

function bte_rw_update_sitelinks($ID,$v) {
	bte_rw_reset_sitelinks($ID);
	for($i=0; $i<$v->arraysize(); $i++)
	{
		$rec=$v->arraymem($i);
		if (BTE_RW_DEBUG) {
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_sitelinks] ".$post->guid." [".i."] ID: ".$ID);
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_sitelinks] ".$post->guid." [".i."] link: ".$rec->structmem("link")->scalarval());
			error_log("[".date('Y-m-d H:i:s')."][bte_rwplugin.bte_rw_update_sitelinks] ".$post->guid." [".i."] excerpt: ".$rec->structmem("excerpt")->scalarval());
		}
		bte_rw_insert_sitelink($ID,$rec->structmem("link")->scalarval(),$rec->structmem("excerpt")->scalarval());
	}
}

function bte_rw_reset_links($ID) {
	global $wpdb;
   	$table_name = $wpdb->prefix . "bte_rw_sites";
	$sql = "DELETE FROM $table_name WHERE post_id=$ID;";
	$res = $wpdb->query($sql);
}

function bte_rw_reset_sitelinks($ID) {
	global $wpdb;
   	$table_name = $wpdb->prefix . "bte_rw_posts";
	$sql = "DELETE FROM $table_name WHERE post_id=$ID;";
	$res = $wpdb->query($sql);
}

function bte_rw_insert_link($ID,$link,$excerpt) {
	global $wpdb;
   	$table_name = $wpdb->prefix . "bte_rw_sites";
	$sql = "INSERT INTO $table_name SET post_id=$ID, link='$link',excerpt='$excerpt';";
	$res = $wpdb->query($sql);
}
function bte_rw_insert_sitelink($ID,$link,$excerpt) {
	global $wpdb;
   	$table_name = $wpdb->prefix . "bte_rw_posts";
	$sql = "INSERT INTO $table_name SET post_id=$ID, link='$link',excerpt='$excerpt';";
	$res = $wpdb->query($sql);
}

function bte_rw_get_links($num=0) {
	global $wpdb;
	global $post;
	global $bte_rw_encoder;
	if ($bte_rw_encoder==null)	{
		$bte_rw_encoder = new BTE_RW_GE;
	}
   	if ($num==0)
   	{
	   	$numLink = get_option('bte_rw_links');
		if (!(isset($numLink) && is_numeric($numLink))) {
			$numLink = 5;
		}
   	} else {
   		$numLink=$num;
   	}
   	if ($numLink<1) {
   		$numLink=5;
   	}

   	$linksLinktitle = get_option('bte_rw_links_linktitle');
   	$linksTitle = stripslashes(get_option('bte_rw_links_title'));
   	$linksHeader = stripslashes(get_option('bte_rw_links_header'));
   	$linksFooter = stripslashes(get_option('bte_rw_links_footer'));
   	$linkHeader = stripslashes(get_option('bte_rw_link_header'));
   	$linkFooter = stripslashes(get_option('bte_rw_link_footer'));
   	$linkExcerpt = get_option('bte_rw_link_excerpt');
   	$linkExcerptHeader = stripslashes(get_option('bte_rw_link_excerpt_header'));
   	$linkExcerptFooter = stripslashes(get_option('bte_rw_link_excerpt_footer'));

   	$table_name = $wpdb->prefix . "bte_rw_sites";
	$sql = "SELECT link,excerpt FROM $table_name WHERE post_id=$post->ID ORDER BY rand() LIMIT $numLink";
	$links = $wpdb->get_results($sql);

	$sitestr = "$linksTitle";
	if ($linksLinktitle){
		$sitestr = '<a href="http://www.blogtrafficexchange.com/related-websites">'.$sitestr.'</a>';
	}
	$sitestr .= " $linksHeader ";
	$i=0;
	foreach ($links as $link) {
		$i++;
		$sitestr .= " $linkHeader ".$bte_rw_encoder->Decode($link->link,$post->guid);
		if ($linkExcerpt>0) {
			$sitestr .= " $linkExcerptHeader".bte_rw_excerpt($bte_rw_encoder->Decode($link->excerpt,$post->guid),$linkExcerpt).$linkExcerptFooter;
		}
		$sitestr .= " $linkFooter";
	}
	
	$sitestr .= " $linksFooter";
	if ($i>0) {
		return $sitestr;
	}
	return "";
}

function bte_rw_get_posts($num=0) {
	global $wpdb;
	global $post;
	global $bte_rw_encoder;
	if ($bte_rw_encoder==null)	{
		$bte_rw_encoder = new BTE_RW_GE;
	}
   	if ($num==0)
   	{
	   	$numLink = get_option('bte_rw_links');
		if (!(isset($numLink) && is_numeric($numLink))) {
			$numLink = 5;
		}
   	} else {
   		$numLink=$num;
   	}
   	if ($numLink<1) {
   		$numLink=5;
   	}
   	$linksLinktitle = get_option('bte_rw_posts_linktitle');
   	$linksTitle = stripslashes(get_option('bte_rw_posts_title'));
   	$linksHeader = stripslashes(get_option('bte_rw_posts_header'));
   	$linksFooter = stripslashes(get_option('bte_rw_posts_footer'));
   	$linkHeader = stripslashes(get_option('bte_rw_post_header'));
   	$linkFooter = stripslashes(get_option('bte_rw_post_footer'));
   	$linkExcerpt = get_option('bte_rw_post_excerpt');
   	$linkExcerptHeader = stripslashes(get_option('bte_rw_post_excerpt_header'));
   	$linkExcerptFooter = stripslashes(get_option('bte_rw_post_excerpt_footer'));
   	
   	$table_name = $wpdb->prefix . "bte_rw_posts";
	$sql = "SELECT link,excerpt FROM $table_name WHERE post_id=$post->ID ORDER BY rand() LIMIT $numLink";
	$links = $wpdb->get_results($sql);

	$webstr = "$linksTitle";
	if ($linksLinktitle) {
		$webstr = '<a href="http://www.blogtrafficexchange.com/related-posts">'.$webstr.'</a>';
	}
	$webstr .= " $linksHeader ";
	$i=0;
	foreach ($links as $link) {
		$i++;
		$webstr .= " $linkHeader ".$bte_rw_encoder->Decode($link->link,$post->guid);
		if ($linkExcerpt>0) {
			$webstr .= " $linkExcerptHeader".bte_rw_excerpt($bte_rw_encoder->Decode($link->excerpt,$post->guid),$linkExcerpt).$linkExcerptFooter;
		}
		$webstr .= " $linkFooter";
	}
	$webstr .= " $linksFooter";
	if ($i>0) {
		return $webstr;
	}
	return "";
}

function bte_rw_the_content($content) {
	global $post;
	$postMod = get_post_modified_time();
	$last = get_post_meta($post->ID, '_bte_rw_last_content_update', true);
	if ($post->post_type == 'post' && $post->post_status == 'publish' && (!(isset($last) && $last!='') || $postMod>$last)) {
		bte_rw_updateContent($postMod);
		update_post_meta($post->ID,'_bte_rw_last_link_update',time()) or add_post_meta($post->ID, '_bte_rw_last_link_update', time());					
		delete_post_meta($post->ID, '_bte_rw_update_links');
	} else if (get_post_meta($post->ID, '_bte_rw_update_links', true)=="true") {
		bte_rw_updatePostLinks($post->ID,$post->guid);		
		update_post_meta($post->ID,'_bte_rw_last_link_update',time()) or add_post_meta($post->ID, '_bte_rw_last_link_update', time());					
		delete_post_meta($post->ID, '_bte_rw_update_links');
	}
	
	$show = get_option('bte_rw_posts_add');
	if ($post->post_type == 'post' && $post->post_status == 'publish' && $show) {
		$content .= " ".bte_rw_get_posts();
	}		
	$show = get_option('bte_rw_links_add');
	if ($post->post_type == 'post' && $post->post_status == 'publish' && $show) {
		$content .= " ".bte_rw_get_links();
	}		
	return $content;
}

function bte_rw_the_excerpt($content) {
	global $post;
	$postMod = get_post_modified_time();
	$last = get_post_meta($post->ID, '_bte_rw_last_content_update', true);
	if ($post->post_type == 'post' && $post->post_status == 'publish' && (!(isset($last) && $last!='') || $postMod>$last)) {
		bte_rw_updateContent($postMod);
		update_post_meta($post->ID,'_bte_rw_last_link_update',time()) or add_post_meta($post->ID, '_bte_rw_last_link_update', time());					
		delete_post_meta($post->ID, '_bte_rw_update_links');
	} else if (get_post_meta($post->ID, '_bte_rw_update_links', true)=="true") {
		bte_rw_updatePostLinks($post->ID,$post->guid);		
		update_post_meta($post->ID,'_bte_rw_last_link_update',time()) or add_post_meta($post->ID, '_bte_rw_last_link_update', time());					
		delete_post_meta($post->ID, '_bte_rw_update_links');
	}
	return $content;
}

function bte_rw_wake() {
	if (rand()%99==0) {//1% of the time reset old links for refresh
		global $wpdb;
		$table_name = $wpdb->prefix . "bte_rw_sites";
		$threshold = time()-BTE_RW_24_HOURS;
		$sql = "INSERT INTO $wpdb->postmeta (post_id,meta_key,meta_value) SELECT p.ID,'_bte_rw_update_links','true' FROM $wpdb->posts p INNER JOIN $wpdb->postmeta pm ON p.ID=pm.post_id and pm.meta_key='_bte_rw_last_link_update' and pm.meta_value<$threshold;";
		$wpdb->query($sql);
	}
}

?>
